<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1">
<title>Task 35.40 -List of users</title>
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<style>

  .div-title {
    font-size: 40px;
    height: 80px;
    color: rgb(0, 195, 255);
    text-align: center;
    margin-top: 50px;
  }

  .div-name-filter {
    height: 100px;
    align-items: center;
    margin-left: 135px;
    margin-right: 135px;
    background-color: rgb(235, 235, 235);
  }

  .div-table {
    margin-top: 40px;
    margin-bottom: 50px;
    padding-left: 150px;
    padding-right: 150px;
  }

   .div-head {
    text-align: center;
  }
</style>

<body>

  <div class="container-fluid">
    <div  class="div-title"><b>LIST OF USERS</b></div>
    <div class="row div-name-filter">
      <div class="col-sm-4 text-right">
        <label>Name:</label>
      </div>
      <div class="col-sm-4 text-left">
        <input id="name-input" class="form-control" type="text" placeholder="...">
      </div>
      <div>
        <a id="user-filter-btn" type="button" class="btn btn-primary" style="color: white;">User Filter</a>
      </div>
    </div>

  </div>

  <div class="div-table">
    <table id="user-table" class="table table-bordered table-hover table-striped ">
      <thead>
        <tr class="div-head">
          <th>No.</th>
          <th>Name</th>
          <th>Username</th>
          <th>Email</th>
          <th>Address</th>
          <th>Zipcode</th>
          <th>Phone</th>
          <th>Company</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
         </tbody>
    </table>
  </div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    
    const gBASE_URL = "https://jsonplaceholder.typicode.com/users/";
    var gUserObj = [];

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  
    //load the data of users
    $(document).ready(loadUserData);

    //add click event for the Detail Button 
    $("#user-table").on('click', ".btn-detail", onDetailBtnClick);
    
    //add event handler for Filter Button
    $("#user-filter-btn").on('click', btnFilterClick);

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  
    //function on loading data of the users
    function loadUserData(){

      //call API for getting the comments' list
      $.ajax ({
            url: gBASE_URL,
            type: "GET",
            success: function(res){
              console.log(res);
              loadDataToTable(res);
              gUserObj.push(res);
              console.log(gUserObj);
            },
            error: function(ajaxContext){
              console.log(ajaxContext);
            },
          });
    };
  
    //function for loading the data to table
    function loadDataToTable(paramData){

      var vTable = $("#user-table");
      
      for (var bI=0; bI < paramData.length; bI++){
        //create a row of the table
        var vNewRow = $("<tr>").appendTo(vTable);
              
        //create cells of the rows
        $("<td>", {html: paramData[bI].id}).attr("class", "text-center").appendTo(vNewRow);
        $("<td>", {html: paramData[bI].name}).appendTo(vNewRow);
        $("<td>", {html: paramData[bI].username}).appendTo(vNewRow);
        $("<td>", {html: paramData[bI].email}).appendTo(vNewRow);

        $("<td>")
          .html(paramData[bI].address.suite + "," + paramData[bI].address.street + "," + paramData[bI].address.city)
          .appendTo(vNewRow);
      
        $("<td>", {html: paramData[bI].address.zipcode}).appendTo(vNewRow);
        $("<td>", {html: paramData[bI].phone}).appendTo(vNewRow);
        $("<td>", {html: paramData[bI].company.name}).appendTo(vNewRow);
          
        //create Detail Button in the action column
        var vAction = $("<td>").appendTo(vNewRow);
        var vDetailBtn = $("<button>")
        .html("Detail")
        .attr("class", "btn btn-warning btn-detail")
        .data("id", paramData[bI].id)
        .appendTo(vAction);
        //add click event for the Detail Button  
        //vDetailBtn.click(onDetailBtnClick);
      };
    };
    
    //function for Detail Button
    function onDetailBtnClick(){
      
      console.log("%cUSER'S ID: ", "color:orange", $(".btn-detail").data("id"));

      //add query string and access User Detail
      const vUSER_DETAIL = "file:///C:/Users/hphat/Desktop/J2232/2023-02-28/Task%2035.40/Task%2035.40%20-%20User's%20Detail.html";
      //var vID = paramData.currentTarget;
      var vUrlToSideOpen = vUSER_DETAIL + "?" + "id=" + $(".btn-detail").data("id");
      window.location.href = vUrlToSideOpen;

    };
  
    //function for Filter Button
    function btnFilterClick(){
      
      //creat filter object
      var vNameFilterObj = {name: ""};

      //read the filter data
      var vNameFilterElement = $("#name-input");
          vNameFilterObj.name = $.trim(vNameFilterElement.val());
          
      //validate the filter data
      if (vNameFilterObj.name == ""){
        alert("Please input name !!!");
        return false;
      }
      if (vNameFilterObj.name != ""){
        
        //add filter event handler
        var vFilterRes = filterEventHandler(vNameFilterObj);

        //clear the table data before displaying the filter's result on table
        var vTable = $("#user-table"); 
            vTable.find("tr:gt(0)").html(""); 

        //display the filter's result on the table
        if (vFilterRes.length > 0){
          alert("There are " + vFilterRes.length + " results matching the filter");
          loadDataToTable(vFilterRes);
        }
        else {
          alert("There is no matching result");
          return false;
        }
      }
    }

    //event handler for FilterButton
    function filterEventHandler(paramData){
    console.log("clicked" + paramData.name);
    console.log("gUser: " + gUserObj);
    var vResObjArray = [];
    
    if (paramData.name != ""){
      for (var bI=0; bI < gUserObj[0].length; bI++){
        var bIObjMatch = gUserObj[0][bI];
        if (paramData.name.toLowerCase() === bIObjMatch.name.toLowerCase()){
          vResObjArray.push(bIObjMatch);
        };
      };
      return vResObjArray;
    };
  };

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

 </script>

</html>
